%% Figure 1E - dprime
%
clear all
close all
%%
%Inital learning
dprime_Ini     = [-0.401 -0.588 1.290 3.162 3.895 3.805]; %Initial
%Reversal learning
dprime_Rev     = [-0.767 -0.338 1.548 2.599 2.183];       %Reversal

for iLearning = 1:2
    switch iLearning
        case 1
            figure('Name', ['Initial_Taskperfrmance'])
            set(gcf,'Position',[100 100 210 350])
            dprime = dprime_Ini;
            FigTitle = 'Initial';
        case 2
            figure('Name', ['Reversal_Taskperfrmance'])
            set(gcf,'Position',[100 100 210 350])
            dprime = dprime_Rev;
            FigTitle = 'Reversal';
    end
    
    plot(dprime, '-o', 'color',[0.25 0.85 0.25],'MarkerFaceColor',[0.25 0.85 0.25]);
    hline(1.5);
    NofSession = size(dprime,2);

    xlim([0 NofSession+1]);
    ylim ([-1 4.5]);
    
    NofXticks = 1:1:NofSession;
    xticks(NofXticks);
    yticks([-1 0 1 2 3 4]);
    title(FigTitle);
    xlabel('Session')
    ylabel('Task performance')
    ax = gca;
    ax.FontSize = 12;
    set(ax, {'ycolor'},{'k'})
    box off
      
end %for iLearning
