%% Fig. 2C_LinePlot - k-mean groups Go Expert-Expert
clear all
close all
% ==========================================================================
%% k-means cluster lineplot (Expert-Expert in Go trial)
% ==========================================================================
%Prepare variables
load('Fig2C_LinePlot.mat');
TimeWinFrame = [-15:1:120];% -0.5 s to 4.0 s 
fs = 30;

%%
ColorCode = [0 0 1; 1 0 0; 0.75 0.75 0.75; 0.5 0.5 0.5];
NofCluster = 9;
for iCluster = 1:NofCluster
    
    switch iCluster
        case 1
            FigTitle = 'StableUp';
        case 2
            FigTitle = 'RampUp';
        case 3
            FigTitle = 'RampDown';
        case 4
            FigTitle = 'IniUp';
        case 5
            FigTitle = 'RevUp';
        case 6
            FigTitle = 'Ini-RampUp';
        case 7
            FigTitle = 'Ini-RampDown';
        case 8
            FigTitle = 'Rev-RampUp';
        case 9
            FigTitle = 'Rev-RampDown';
    end
    
    fig=figure;
    fig.Position = [400 550 345 164];
    
    for iPhase = 1:4
        Mean = LineMean(iCluster, :, iPhase);
        SEM  = LineSEM(iCluster, :, iPhase);
        shadedErrorBar2(TimeWinFrame/fs, Mean, SEM, {'-','color', ColorCode(iPhase, :)});
        hold on;
    end
    box off;
    xlim([-0.5 4.0]);
    ylim([-0.8 0.8]);
    hline(0,'k')
    title(FigTitle);
end
