addpath(genpath('...\auxillary'));

% SVM decoding
load('...\decoding\DataAll.mat')
load('...\decoding\ZLowCa.mat')

SampleRate=30;
StimDur=2;%second
WindExcInh=2;%second 1s
NormBaseline=1;%second before stimOn 1s
AfterStimDur=2;%second after stimOff 2s
AudFreq=[4000 8000 12000 16000 20000 0];
VisDeg=[0 90 180 270 720];
FeatureResampleFactor=10;% 1/10 resampling of 30 Hz signal to avoid feature>sample
BatchName={'Aud1','Vis1'};
StageName={'Pre','Post'};


for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                t{1,iBatch}{iSub,iTrainStage}{iSession,1}=DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.ScanStamp;
                StimOnT{1,iBatch}{iSub,iTrainStage}{iSession,1}=DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.StimStart;
                StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}=dsearchn(t{1,iBatch}{iSub,iTrainStage}{iSession,1},StimOnT{1,iBatch}{iSub,iTrainStage}{iSession,1});
                StimOffInd{1,iBatch}{iSub,iTrainStage}{iSession,1}=StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}+StimDur*SampleRate;
                StimExcInhWindInd{1,iBatch}{iSub,iTrainStage}{iSession,1}=StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}+WindExcInh*SampleRate;
                StimBaseOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}=StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}-NormBaseline*SampleRate;
                StimOffAfterInd{1,iBatch}{iSub,iTrainStage}{iSession,1}=StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}+(StimDur+AfterStimDur)*SampleRate;
                
                for iCell=1:size(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.ICF,2)
                    for iTrial=1:size(StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1},1)
                        % feature3{1,iBatch}{iSub,iTrainStage}{iSession,1}(time,stimType,cell)
                        zF0=mean(ZRawCa{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (StimBaseOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial):StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial),iCell));
                        StimDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,iTrial,iCell)=...
                            ZRawCa{1,iBatch}{iSub,iTrainStage}{iSession,1}(...
                            StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial):...
                            StimOffInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial)-1,iCell)...
                            -zF0;
                        StimMeanDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial,iCell)=...
                            mean(ZRawCa{1,iBatch}{iSub,iTrainStage}{iSession,1}(...
                            StimOnInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial):...
                            StimExcInhWindInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(iTrial)-1,iCell)...
                            -zF0);
                    end
                end
                
                % stim type
                for iAud=1:6%audFreq
                    AudTrial{1,iBatch}{iSub,iTrainStage}{iSession,iAud}=find(...
                        DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.Trial_Freq==AudFreq(iAud));
                end
                for iVis=1:5%visDeg
                    VisTrial{1,iBatch}{iSub,iTrainStage}{iSession,iVis}=find(...
                        DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.Trial_Grat==VisDeg(iVis));
                end
            end
        end
    end
end
clear zF0


clear StimAudVis StimAud StimVis StimMeanAudVis StimMeanAud
for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                for iAud=1:5%aud
                    for iCell=1:size(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.ICF,2)
                        % aud+vis Stim Window time series
                        StimAudVis{1,iBatch}{iSub,iTrainStage}{iSession,iAud}(:,:,iCell)=...
                            StimDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (:,intersect(AudTrial{1,iBatch}{iSub,iTrainStage}{iSession,iAud},...
                            cell2mat(VisTrial{1,iBatch}{iSub,iTrainStage}(iSession,1:4)')),iCell)';
                        % aud Stim Window time series
                        StimAud{1,iBatch}{iSub,iTrainStage}{iSession,iAud}(:,:,iCell)=...
                            StimDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}....
                            (:,intersect(AudTrial{iBatch}{iSub,iTrainStage}{iSession,iAud},...
                            VisTrial{1,iBatch}{iSub,iTrainStage}{iSession,5}),iCell)';
                        % aud+vis Stim Window mean
                        StimMeanAudVis{1,iBatch}{iSub,iTrainStage}{iSession,iAud}(:,iCell)=...
                            StimMeanDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (intersect(AudTrial{1,iBatch}{iSub,iTrainStage}{iSession,iAud},...
                            cell2mat(VisTrial{1,iBatch}{iSub,iTrainStage}(iSession,1:4)')),iCell)';
                        % aud Stim Window mean
                        StimMeanAud{1,iBatch}{iSub,iTrainStage}{iSession,iAud}(:,iCell)=...
                            StimMeanDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}....
                            (intersect(AudTrial{1,iBatch}{iSub,iTrainStage}{iSession,iAud},...
                            VisTrial{1,iBatch}{iSub,iTrainStage}{iSession,5}),iCell)';
                    end
                end
                for iVis=1:4
                    for iCell=1:size(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}){iSession}.ICF,2)
                        % aud+vis Stim Window time series
                        StimVisAud{1,iBatch}{iSub,iTrainStage}{iSession,iVis}(:,:,iCell)=...
                            StimDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (:,intersect(cell2mat(AudTrial{1,iBatch}{iSub,iTrainStage}(iSession,1:5)'),...
                            VisTrial{1,iBatch}{iSub,iTrainStage}{iSession,iVis}),iCell)';
                        % vis Response Window time series
                        StimVis{1,iBatch}{iSub,iTrainStage}{iSession,iVis}(:,:,iCell)=...
                            StimDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (:,intersect(AudTrial{iBatch}{iSub,iTrainStage}{iSession,6},...
                            VisTrial{iBatch}{iSub,iTrainStage}{iSession,iVis}),iCell)';
                        % Vis+Aud Response Window mean
                        StimMeanVisAud{1,iBatch}{iSub,iTrainStage}{iSession,iVis}(:,iCell)=...
                            StimMeanDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (intersect(cell2mat(AudTrial{1,iBatch}{iSub,iTrainStage}(iSession,1:5)'),...
                            VisTrial{1,iBatch}{iSub,iTrainStage}{iSession,iVis}),iCell)';
                        % vis Response Window mean
                        StimMeanVis{1,iBatch}{iSub,iTrainStage}{iSession,iVis}(:,iCell)=...
                            StimMeanDfZ{1,iBatch}{iSub,iTrainStage}{iSession,1}...
                            (intersect(AudTrial{iBatch}{iSub,iTrainStage}{iSession,6},...
                            VisTrial{iBatch}{iSub,iTrainStage}{iSession,iVis}),iCell)';
                    end
                end
            end
        end
    end
end

%% design matrix
% auditory freq decoding

% time series feature
% aud freq
for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                tempAudVis=[];tempAud=[];
                for iAud=1:5%aud
                    % StimAudVis(iTrial(AudFreq),time,iCell)
                    temp=StimAudVis{1,iBatch}{iSub,iTrainStage}{iSession,iAud};
                    temp=reshape(temp,size(temp,1),size(temp,2)*size(temp,3));
                    tempAudVis=cat(1,tempAudVis,temp);
                    temp1=StimAud{1,iBatch}{iSub,iTrainStage}{iSession,iAud};
                    temp1=reshape(temp1,size(temp1,1),size(temp1,2)*size(temp1,3));
                    tempAud=cat(1,tempAud,temp1);
                end
                label=reshape(repmat([4;8;12;16;20],1,size(temp,1))',size(tempAudVis,1),1);
                AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}=[tempAudVis,label];
                label=reshape(repmat([4;8;12;16;20],1,size(temp1,1))',size(tempAud,1),1);
                AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}=[tempAud,label];
                clear temp* label
            end
        end
    end
end

% Aud Vis AudVis decoding
clear AudVisMat AudMat VisMat AudVisMeanMat AudMeanMat VisMeanMat

for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                tempAudVis=[];tempAud=[];
                for iAud=1:5%aud
                    % StimAudVis(iTrial(AudFreq),time,iCell)
                    temp=StimAudVis{1,iBatch}{iSub,iTrainStage}{iSession,iAud};
                    temp=reshape(temp,size(temp,1),size(temp,2)*size(temp,3));
                    tempAudVis=cat(1,tempAudVis,temp);
                    temp1=StimAud{1,iBatch}{iSub,iTrainStage}{iSession,iAud};
                    temp1=reshape(temp1,size(temp1,1),size(temp1,2)*size(temp1,3));
                    tempAud=cat(1,tempAud,temp1);
                end
                % AudVis matrix
                label=ones(size(tempAudVis,1),1);
                AudVisMat{1,iBatch}{iSub,iTrainStage}{iSession,1}=[tempAudVis,label];
                %Aud matrix
                label=2*ones(size(tempAud,1),1);
                AudMat{1,iBatch}{iSub,iTrainStage}{iSession,1}=[tempAud,label];
                
                tempVis=[];
                for iVis=1:4
                    temp2=StimVis{1,iBatch}{iSub,iTrainStage}{iSession,iVis};
                    temp2=reshape(temp2,size(temp2,1),size(temp2,2)*size(temp2,3));
                    tempVis=cat(1,tempVis,temp2);
                end
                %Vis matrix
                label=3*ones(size(tempVis,1),1);
                VisMat{1,iBatch}{iSub,iTrainStage}{iSession,1}=[tempVis,label];
                clear temp* label
            end
        end
    end
end



%% decode Aud Vis AudVis train one test another pre post (Modality)

% Train 80% data test on other with same train and test index
SVM_Template=templateSVM('KernelFunction','linear','PolynomialOrder',[],'KernelScale','auto',...
    'BoxConstraint',1,'Standardize',false);

clear temp* TrianInd
TrainPrc=1;
nItration=50;
nShuffle=100;
HoldOut=0.3;


for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                tic
                for it=1:nItration
                    temp=[AudVisMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        AudMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        VisMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    TrainNum=floor(min([sum(temp(:,end)==1) sum(temp(:,end)==2) sum(temp(:,end)==3)])*TrainPrc);
                    TrainInd1=[];TestInd1=[];
                    for iModality=1:3
                        [temp1,~]=find(temp(:,end)==iModality);
                        tempInd=randperm(length(temp1),TrainNum);
                        % select 50% of trial for training
                        tempTrainInd=~cvpartition(TrainNum,'HoldOut',HoldOut).test;
                        TrainInd1=cat(1,TrainInd1,temp1(tempInd(tempTrainInd)));
                        TestInd1=cat(1,TestInd1,temp1(tempInd(~tempTrainInd)));
                    end
                    TrianInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it)=TrainInd1;
                    TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it)=TestInd1;
                    % Aud/Vis/AudVis classifier
                    tempLow=resample(double(temp(TrainInd1,1:end-1))',1,FeatureResampleFactor)';%resample
                    ClassifierModalitySVM{1,iBatch}{iSub,iTrainStage}{iSession,it}=fitcecoc(...
                        tempLow,temp(TrainInd1,end),...
                        'Learners', SVM_Template,'Coding', 'onevsall','ClassNames',[1;2;3]);

                    parfor iShuffle=1:nShuffle
                        temp2=tempLow;
                        for i=1:size(temp2,1)
                            temp2(i,:)=circshift(temp2(i,:),randi([1 size(temp2,2)]));
                        end
                        %shuffle feature for each trial (circular permute)
                        temp3{it,iShuffle}=fitcecoc(temp2,temp(TrainInd1,end),...
                            'Learners', SVM_Template,'Coding', 'onevsall','ClassNames',[1;2;3]);
                    end
                    ClassifierModalitySVMShuffle{1,iBatch}{iSub,iTrainStage}{iSession,1}=temp3;
                    clear temp temp2
                end
                clear temp3
                toc
                
            end
        end
    end
end
delete(gcp)

% predict Modality
for iBatch=1:2
    for iSub=1:size(DataAll.(BatchName{iBatch}),1)
        tic
        clear temp* Cat*
        for it=1:nItration
            i=1;
            for iTrainStage=1:2 %Pre Post
                for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                    CatClassifier{i,1}=ClassifierModalitySVM{1,iBatch}{iSub,iTrainStage}{iSession,it};
                    temp=[AudVisMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        AudMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        VisMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    tempLow=resample(double(temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                        1:end-1))',1,FeatureResampleFactor)';%resample
                    CatTestData{i,1}=tempLow;
                    CatTrueLabel{i,1}=temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                        end);
                    i=i+1;
                end
            end
            
            for i=1:length(CatClassifier)
                for j=1:length(CatClassifier)
                    temp1{it,1}(i,j)=sum(predict(CatClassifier{i,1},...
                        CatTestData{j,1})==CatTrueLabel{j,1})/length(CatTrueLabel{j,1});
                end
            end
        end
        ModalityAccuracyAll{iSub,iBatch}=temp1;
        ModalityAccuracy{iSub,iBatch}=mean(reshape(cell2mat(squeeze(...
            temp1(:,1))'),size(temp1{it,1},1),size(temp1{it,1},1),nItration),3);
        
        
        % shuffle feature for each trial
        clear temp* Cat*
        for it=1:nItration
            for iShuffle=1:nShuffle
                i=1;
                for iTrainStage=1:2 %Pre Post
                    for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                        CatClassifier{i,iShuffle}=ClassifierModalitySVMShuffle...
                            {1,iBatch}{iSub,iTrainStage}{iSession,1}{it,iShuffle};
                        temp=[AudVisMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                            AudMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                            VisMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                        tempLow=resample(double(temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                            1:end-1))',1,FeatureResampleFactor)';%resample
                        CatTestData{i,iShuffle}=tempLow;
                        CatTrueLabel{i,iShuffle}=temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                            end);
                        i=i+1;
                    end
                end
            end
            
            for i=1:size(CatClassifier,1)
                for j=1:size(CatClassifier,1)
                    for iShuffle=1:nShuffle
                        temp1{it,iShuffle}(i,j)=sum(predict(CatClassifier{i,iShuffle},...
                            CatTestData{j,iShuffle})==CatTrueLabel{j,iShuffle})/length(CatTrueLabel{j,iShuffle});
                    end
                end
            end
        end
        
        ModalityAccuracyShuffleAll{iSub,iBatch}=temp1;
        for it=1:nItration
            temp2(:,:,it)=mean(reshape(cell2mat(...
                temp1(it,:)),size(temp1{it,1},1),size(temp1{it,1},1),nShuffle),3);
        end
        ModalityAccuracyShuffle{iSub,iBatch}=mean(temp2,3);
        toc
    end
end

clear Cat* temp* TrainInd* TestInd* Classifier*

temp=reshape(ModalityAccuracy,8,1);
ModalityAccuracyGroup=temp(~cellfun(@isempty,temp));
temp1=reshape(ModalityAccuracyShuffle,8,1);
ModalityAccuracyGroupShuffle=temp1(~cellfun(@isempty,temp1));

tempCAxis=[.3 .7];
figure
for i=1:6
    subplot(2,6,i)
    imagesc(ModalityAccuracyGroup{i,1}')
    axis square
    caxis(tempCAxis)
    subplot(2,6,i+6)
    imagesc(ModalityAccuracyGroupShuffle{i,1}')
    axis square
    caxis(tempCAxis)
end


colorbar

% manual select matrix entry to group block decoding
[PreCrossAccuracy,PreCrossAccuracyMeanBlock,PostCrossAccuracy,PostCrossAccuracyMeanBlock,...
    IntraDayAccuracy,IntraDayAccuracyMeanBlock,PrePostAccuracy,PrePostAccuracyMeanBlock]=...
    GroupBlock(ModalityAccuracyGroup);

[PreCrossAccuracyShuffle,PreCrossAccuracyMeanBlockShuffle,PostCrossAccuracyShuffle,...
    PostCrossAccuracyMeanBlockShuffle,IntraDayAccuracyShuffle,IntraDayAccuracyMeanBlockShuffle,...
    PrePostAccuracyShuffle,PrePostAccuracyMeanBlockShuffle]=...
    GroupBlock(ModalityAccuracyGroupShuffle);


x=[IntraDayAccuracy;PreCrossAccuracy;PostCrossAccuracy;PrePostAccuracy];%;PostCrossAccuracy
x1=[IntraDayAccuracyShuffle;PreCrossAccuracyShuffle;PostCrossAccuracyShuffle;PrePostAccuracyShuffle];
label=[string(repmat(['IntraDay'],length(IntraDayAccuracy),1));
    string(repmat(['PreCrossDay'],length(PreCrossAccuracy),1));
    string(repmat(['PostCrossDay'],length(PostCrossAccuracy),1));
    string(repmat(['PrePostCrossDay'],length(PrePostAccuracy),1))];%  string(repmat(['PostCrossDay'],length(PostCrossAccuracy),1));

figure
hold on
violinplot(x,label,'ViolinColor',hex2rgb('#D35400'),'GroupOrder',{'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'});
violinplot(x1,label,'ViolinColor',hex2rgb('#2980B9'),'GroupOrder',{'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'});
ylim([0.2 1])
% ranksum test against shuffle
tempLabel={'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'};
for i=1:4
   [p(i),~, stats{i}]=ranksum(x(find(ismember(label,tempLabel{i}))),x1(find(ismember(label,tempLabel{i}))));
end


%% decode Aud Freq by combining Multi and Uni stim
SVM_Template=templateSVM('KernelFunction','linear','PolynomialOrder',[],'KernelScale','auto',...
    'BoxConstraint',1,'Standardize',false);


clear temp* TrianInd
TrainPrc=1;
nItration=50;
nShuffle=100;
HoldOut=0.3;

for iBatch=1:2
    for iTrainStage=1:2 %Pre Post
        for iSub=1:size(DataAll.(BatchName{iBatch}),1)
            for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                tic
                for it=1:nItration
                    % multi-uni mix
                    temp=[AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    % uni
%                     temp=[AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    % multi
%                     temp=[AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    
                    TrainInd1=[];TestInd1=[];
                    for iFreq=4:4:20
                        [temp1,~]=find(temp(:,end)==iFreq);
                        % select x% of trial for training
                        tempTrainInd=~cvpartition(length(temp1),'HoldOut',HoldOut).test;
                        TrainInd1=cat(1,TrainInd1,temp1(tempTrainInd));
                        TestInd1=cat(1,TestInd1,temp1(~tempTrainInd));
                    end
                    TrianInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it)=TrainInd1;
                    TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it)=TestInd1;
                    
                    tempLow=resample(double(temp(TrainInd1,1:end-1))',1,FeatureResampleFactor)';%resample
                    ClassifierFreqSVM{1,iBatch}{iSub,iTrainStage}{iSession,it}=fitcecoc(...
                        tempLow,temp(TrainInd1,end),'Learners',SVM_Template,...
                        'Coding', 'onevsall','ClassNames',[4; 8; 12; 16; 20]);
                    
                    parfor iShuffle=1:nShuffle
                        temp2=tempLow;
                        for i=1:size(temp2,1)
                            temp2(i,:)=circshift(temp2(i,:),randi([1 size(temp2,2)]));
                        end
                        %shuffle feature for each trial (circular permute)
                        temp3{it,iShuffle}=fitcecoc(temp2,temp(TrainInd1,end),...
                            'Learners', SVM_Template,'Coding', 'onevsall','ClassNames',[4;8;12;16;20]);
                    end
                    
                    ClassifierFreqSVMShuffle{1,iBatch}{iSub,iTrainStage}{iSession,1}=temp3;
                    clear temp temp2
                end
                clear temp3
                toc
            end
        end
    end
end
delete(gcp)

% predict Aud Freq
for iBatch=1:2
    for iSub=1:size(DataAll.(BatchName{iBatch}),1)
        clear temp* Cat*
        tic
        for it=1:nItration
            i=1;
            for iTrainStage=1:2 %Pre Post
                for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                    CatClassifier{i,1}=ClassifierFreqSVM{1,iBatch}{iSub,iTrainStage}{iSession,it};
                    % multi+uni
                    temp=[AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                        AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    % uni
%                     temp=[AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                    % multi
%                     temp=[AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];

                    tempLow=resample(double(temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),1:end-1))',1,FeatureResampleFactor)';%resample
                    CatTestData{i,1}=tempLow;
                    CatTrueLabel{i,1}=temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                        end);
                    i=i+1;
                end
            end
            
            for i=1:length(CatClassifier)
                for j=1:length(CatClassifier)
                    temp1{it,1}(i,j)=sum(predict(CatClassifier{i,1},...
                        CatTestData{j,1})==CatTrueLabel{j,1})/length(CatTrueLabel{j,1});
                end
            end
        end
        FreqAccuracyAll{iSub,iBatch}=temp1;
        
        FreqAccuracy{iSub,iBatch}=mean(reshape(cell2mat(squeeze(...
            temp1(:,1))'),size(temp1{it,1},1),size(temp1{it,1},1),nItration),3);
        toc
        
        
        % shuffle feature for each trial
        
        for it=1:nItration
            tic
            clear Cat* temp tempLow
            for iShuffle=1:nShuffle
                i=1;
                for iTrainStage=1:2 %Pre Post
                    for iSession=1:length(DataAll.(BatchName{iBatch})(iSub).Multi.(StageName{iTrainStage}))
                        CatClassifier{i,iShuffle}=ClassifierFreqSVMShuffle...
                            {1,iBatch}{iSub,iTrainStage}{iSession,1}{it,iShuffle};
                        temp=[AudVisFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1};...
                            AudFreqMat{1,iBatch}{iSub,iTrainStage}{iSession,1}];
                        tempLow=resample(double(temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),1:end-1))',1,FeatureResampleFactor)';%resample
                        CatTestData{i,iShuffle}=tempLow;
                        CatTrueLabel{i,iShuffle}=temp(TestInd{1,iBatch}{iSub,iTrainStage}{iSession,1}(:,it),...
                            end);
                        i=i+1;
                    end
                end
            end
            
            for i=1:size(CatClassifier,1)
                for j=1:size(CatClassifier,1)
                    for iShuffle=1:nShuffle
                        temp1{it,iShuffle}(i,j)=sum(predict(CatClassifier{i,iShuffle},...
                            CatTestData{j,iShuffle})==CatTrueLabel{j,iShuffle})/length(CatTrueLabel{j,iShuffle});
                    end
                end
            end
            toc
        end
        FreqAccuracyShuffleAll{iSub,iBatch}=temp1;
        
        for it=1:nItration
            temp2(:,:,it)=mean(reshape(cell2mat(...
                temp1(it,:)),size(temp1{it,1},1),size(temp1{it,1},1),nShuffle),3);
        end
        FreqAccuracyShuffle{iSub,iBatch}=mean(temp2,3);
    end
end
clear Classifier* Cat*


temp=reshape(FreqAccuracy,8,1);
FreqAccuracyGroup=temp(~cellfun(@isempty,temp));
temp1=reshape(FreqAccuracyShuffle,8,1);
FreqAccuracyGroupShuffle=temp1(~cellfun(@isempty,temp));

tempCAxis=[.2 .7];
figure
for i=1:6
    subplot(2,6,i)
    imagesc(temp{i,1}')
    axis square
    caxis(tempCAxis)
    subplot(2,6,i+6)
    imagesc(temp1{i,1}')
    axis square
    caxis(tempCAxis)
end
colorbar


% manual select matrix entry to group block decoding
[PreCrossAccuracy,PreCrossAccuracyMeanBlock,PostCrossAccuracy,PostCrossAccuracyMeanBlock,...
    IntraDayAccuracy,IntraDayAccuracyMeanBlock,PrePostAccuracy,PrePostAccuracyMeanBlock]=...
    GroupBlock(FreqAccuracyGroup);

[PreCrossAccuracyShuffle,PreCrossAccuracyMeanBlockShuffle,PostCrossAccuracyShuffle,...
    PostCrossAccuracyMeanBlockShuffle,IntraDayAccuracyShuffle,IntraDayAccuracyMeanBlockShuffle,...
    PrePostAccuracyShuffle,PrePostAccuracyMeanBlockShuffle]=...
    GroupBlock(FreqAccuracyGroupShuffle);

x=[IntraDayAccuracy;PreCrossAccuracy;PostCrossAccuracy;PrePostAccuracy];%;PostCrossAccuracy
x1=[IntraDayAccuracyShuffle;PreCrossAccuracyShuffle;PostCrossAccuracyShuffle;PrePostAccuracyShuffle];
label=[string(repmat(['IntraDay'],length(IntraDayAccuracy),1));
    string(repmat(['PreCrossDay'],length(PreCrossAccuracy),1));
    string(repmat(['PostCrossDay'],length(PostCrossAccuracy),1));
    string(repmat(['PrePostCrossDay'],length(PrePostAccuracy),1))];%  string(repmat(['PostCrossDay'],length(PostCrossAccuracy),1));

figure
hold on
violinplot(x,label,'ViolinColor',hex2rgb('#D35400'),'GroupOrder',{'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'});
violinplot(x1,label,'ViolinColor',hex2rgb('#2980B9'),'GroupOrder',{'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'});
ylim([0 1])
title('5-way Freq')
% ranksum test against shuffle
tempLabel={'IntraDay','PreCrossDay','PostCrossDay','PrePostCrossDay'};
for i=1:4
   [p(i),~, stats{i}]=ranksum(x(find(ismember(label,tempLabel{i}))),x1(find(ismember(label,tempLabel{i}))));
end


