%% sfig. 1C-F_RT plot
% Load necessary data for sfig.1C-F at first
clear all
close all
% ==========================================================================
%% RT plot
% ==========================================================================
%Prepare variables
load('sfig1CF.mat'); 


%% RT histogram ===========================================================
edges = 0:25:1500;
x = 25:25:1500;

for iLearning = 1:2
    %1 = Initial, 2 = Reversal
        switch iLearning
            case 1   
                RT_Naive  = RT_Ini_All{1,1};
                RT_Expert = RT_Ini_All{1,2};
                fig1 = figure('Name', 'RT_Distribution Initial');
                Fig1.Position = [1200 500 400 350];
                Title_Inside = 'Initial';
            case 2
                RT_Naive  = RT_Rev_All{1,1};
                RT_Expert = RT_Rev_All{1,2};
                fig2 = figure('Name', 'RT_Distribution Reversal');
                Fig2.Position = [1200 500 400 350];
                Title_Inside = 'Reversal';
        end%switch
        
        %Plot histogram----------------------------------------------------
        histoData_Naive = histcounts(RT_Naive, edges);
        bar(x, histoData_Naive/length(RT_Naive), 1.0, 'EdgeColor', 'none', 'FaceAlpha', 0.5);
        box off
        hold on
        histoData_Expert = histcounts(RT_Expert, edges);
        bar(x, histoData_Expert/length(RT_Expert), 1.0, 'EdgeColor', 'none', 'FaceAlpha', 0.5);
                
        %x-y lim
        xlim([0 1500])
        xticks([0 300 600 900 1200 1500]);
        ylim([0 0.2])
        yticks([0 0.1 0.2]);
        
        %label
        xlabel('Reaction Time (ms)')
        ylabel('Proportion of trials')
        %legend
        lgd = legend('Naive', 'Expert');
        legend box off
        title(Title_Inside);
end%for iLearning


%% Median RT ==============================================================

for iLearning = 1:2 %1 = Initial, 2 = Reversal
    
    %Plot RT--------------------------------------------------------
    switch iLearning
        case 1
            figTitle = 'MedianRT_Initial';
            figTitle_Inside = 'Initial';
            RT_Naive  = RT_Ini(:,1);
            RT_Expert = RT_Ini(:,2);
            NofMouse = size(RT_Ini,1);
        case 2
            figTitle = 'MedianRT_Reversal';
            figTitle_Inside = 'Reversal';
            RT_Naive  = RT_Rev(:,1);
            RT_Expert = RT_Rev(:,2);
            NofMouse = size(RT_Rev,1);
    end
    
    fig2 = figure('Name', figTitle);
    fig2.Position = [680 558 231 420];

    for iMouse = 1: NofMouse
        plot([RT_Naive(iMouse), RT_Expert(iMouse)], '-o', 'Color', 'k', 'MarkerFaceColor', 'k');
        xlim([0.5 2.5])
        xticks([0.5 1 2 2.5])
        xticklabels({' ', 'Naive', 'Expert', ''});
        
        ylim([200 1000])
        yticks([200 400 600 800 1000]);
        ylabel('Reaction time (ms)');
        title(figTitle_Inside);
        box off
        hold on
    end%for iMouse
    
end%iLearning
