%% sfig. 4B - Heatmap
close all
clear all
% ========================================
%% Plot Heatmap - Go-kmean
% ========================================
%prepare variables
load('sfig4B_Heatmap.mat');
TimeWinFrame = [-15:1:120];% ca -0.5 s to 4.0 s
fs = 30;

fig1 = figure('Name', 'Initial-Reversal Expert k-mean - Go cluster');

for iLearning = 1:2 %1 = Initial Expert, 2 = Reversal_Expert
    switch iLearning
        case 1 %Naive -------------------------------------------------
            subplot(1,2,1);
            title('Initial-Expert')
        case 2 %Expert ------------------------------------------------
            subplot(1,2,2);
            title('Reversal-Expert')
    end%switch-iRow
    
    %Plot heatmap------------------------------------------------------
    imagesc('XData', TimeWinFrame/fs, 'YData', [1 size(CalciumTrace, 1)], 'CData', CalciumTrace(:, :, iLearning))%plot heatmap
    box off
    
    %Line separating clusters
    lims = axis ;
    hold all;
    line(repmat(lims(1:2)', 1,length(trans)),repmat(trans',2,1), 'color','k','linewidth',1)
    
    %Add colorbar
    colorbar;
    colorbar('box','off');
    caxis([-1.5 1.5]);
    colormap(bluewhitered);
    hold on
    
    %Adjust y axis-----------------------------------------------------
    ylim([1 size(CalciumTrace, 1)]);
    yticks([1 size(CalciumTrace, 1)]);
    
    %Adjust x axis-----------------------------------------------------
    xticks([0 2 4]);
    xlabel('Time from Stimulus')
end %for - iLearning
