%% fig. S6J - Population response aligned at 1st anticipatory lcik in Hit trial with/out anticipatory lick
clear all
close all
% ==========================================================================
%% Load data
% ==========================================================================
%Prepare variables
load('figS6J.mat');

% ===========================================
%% Plot population response Hit Lick/Nonlick
% ===========================================
TimeWinFrame4Lick = [-5:12];%-0.15 s to 0.4 s
fs = 30;

fig = figure('Name', 'Aligned at 1st Anticipatory Lick');
fig.Position = [692 610 700 350];
for iPhase = 1:4

    switch iPhase
        case 1
            subplot(1, 2, iPhase);
            h1=shadedErrorBar(TimeWinFrame4Lick/fs, Mean{1,iPhase}, SEM{1,iPhase}, 'lineprops', 'k'); hold on;            
            set([h1.edge], 'Visible', 'off')            

        case 2
            subplot(1, 2, iPhase-1);
            h2=shadedErrorBar(TimeWinFrame4Lick/fs, Mean{1,iPhase}, SEM{1,iPhase}, 'lineprops', 'r'); hold on;                      
            set([h2.edge], 'Visible', 'off')
            hold on
            h2 = legend({'Naive', 'Expert'});
            h2.AutoUpdate = 'off';
            legend boxoff
                        
            xlim([-0.15 0.4])
            xticks([-0.1 0 0.2 0.4]);
            ylim([-0.05 0.1])
            yticks([-0.05 0 0.05 0.1]);
            hline(0, 'k')
            xlabel('Time from lick (s)')
            title('Initial Naive vs Expert')

        case 3
            subplot(1, 2, iPhase-1);
            h3=shadedErrorBar(TimeWinFrame4Lick/fs, Mean{1,iPhase}, SEM{1,iPhase}, 'lineprops', 'k'); hold on;
            set([h3.edge], 'Visible', 'off')

        case 4
            subplot(1, 2, iPhase-2);
            h4=shadedErrorBar(TimeWinFrame4Lick/fs, Mean{1,iPhase}, SEM{1,iPhase}, 'lineprops', 'r'); hold on;
            set([h4.edge], 'Visible', 'off')
            h4 = legend({'Naive', 'Expert'});
            h2.AutoUpdate = 'off';
            legend boxoff
            
            box off
            xlim([-0.15 0.4])
            xticks([-0.1 0 0.2 0.4]);
            ylim([-0.05 0.1])
            yticks([-0.05 0 0.05 0.1]);
            hline(0, 'k')
            xlabel('Time from lick (s)')    
            title('Reversal Naive vs Expert')
    end
end%iPhase
suptitle('PSTH - 1st anticipatroy lick')
