% Helper function with presets.
function J = customcolormap_preset(preset_name)

% flipud({'#2980B9','#5499C7','#7FB3D5','#A9CCE3','#D4E6F1','#EAF2F8','#D35400','#DC7633','#E59866','#EDBB99','#F6DDCC','#FBEEE6'})
    switch(preset_name)
        case 'pasteljet'
            J = customcolormap([0 .25 .5 .75 1], {'#9d0142','#f66e45','#ffffbb','#65c0ae','#5e4f9f'});
        case 'red-yellow-blue'
            J = customcolormap(linspace(0,1,11), {'#a60026','#d83023','#f66e44','#faac5d','#ffdf93','#ffffbd','#def4f9','#abd9e9','#73add2','#4873b5','#313691'});
        case 'red-yellow-green'
            J = customcolormap(linspace(0,1,11), {'#a60126','#d7302a','#f36e43','#faac5d','#fedf8d','#fcffbf','#d7f08b','#a5d96b','#68bd60','#1a984e','#006936'});
        case 'green-yellow-red' 
            J = customcolormap(linspace(0,1,11), fliplr({'#a60126','#d7302a','#f36e43','#faac5d','#fedf8d','#fcffbf','#d7f08b','#a5d96b','#68bd60','#1a984e','#006936'}));
        case 'red-white-blue'
            J = customcolormap(linspace(0,1,11), {'#68011d','#b5172f','#d75f4e','#f7a580','#fedbc9','#f5f9f3','#d5e2f0','#93c5dc','#4295c1','#2265ad','#062e61'});
        case 'r1-b1'
            J = customcolormap(linspace(0,1,11), fliplr(cellstr(rgb2hex(bluewhitered(11)))'));
        case 'r-b'
            J = customcolormap(linspace(0,1,12), fliplr({'#2980B9','#5499C7','#7FB3D5','#A9CCE3','#D4E6F1','#EAF2F8','#FBEEE6','#F6DDCC','#EDBB99','#E59866','#DC7633','#D35400'}));
        case 'orange-white-purple'
            J = customcolormap(linspace(0,1,11), {'#7f3c0a','#b35807','#e28212','#f9b967','#ffe0b2','#f7f7f5','#d7d9ee','#b3abd2','#8073a9','#562689','#2f004d'});
        case 'purple-white-green'
            J = customcolormap(linspace(0,1,11), {'#410149','#762a84','#9b6fac','#c1a5cd','#e7d4e8','#faf6f7','#d7f1d6','#a6db9d','#5aae60','#1c7735','#014419'});
        case 'pink-white-green'
            J = customcolormap(linspace(0,1,11), {'#860454','#c51b7c','#dc75ab','#f0b7da','#ffdeef','#f8f7f7','#e5f4d9','#b9e084','#7fbc42','#4d921e','#276418'});
        case 'brown-white-pool'
            J = customcolormap(linspace(0,1,11), {'#523107','#523107','#bf812c','#e2c17e','#f3e9c4','#f6f4f4','#cae9e3','#81cdc1','#379692','#01665e','#003d2e'});
        otherwise
            error('Unknown preset.');
    end
end